<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 TRANSITIONAL//EN">
<HTML>
<HEAD>
  <META HTTP-EQUIV="Content-Type" CONTENT="text/html; CHARSET=UTF-8">
  <META NAME="GENERATOR" CONTENT="GtkHTML/3.26.0">
</HEAD>
<BODY>
On Tue, 2010-04-13 at 11:25 +1000, Peter Hutterer wrote:
<BLOCKQUOTE TYPE=CITE>
<PRE>
Run git describe on build and push the output into xorg-git-version.h. Then
print that out in the logfile.

Signed-off-by: Peter Hutterer &lt;<A HREF="mailto:peter.hutterer@who-t.net">peter.hutterer@who-t.net</A>&gt;
---
Do we want something like this? Suggestions for less dodgy implementations
are welcome, but the current one passes distcheck.

 GIT-GENERATE-VERSION         |   24 ++++++++++++++++++++++++
 Makefile.am                  |    2 +-
 hw/xfree86/common/xf86Init.c |    5 +++++
 include/Makefile.am          |    7 +++++++
 4 files changed, 37 insertions(+), 1 deletions(-)
 create mode 100755 GIT-GENERATE-VERSION

diff --git a/GIT-GENERATE-VERSION b/GIT-GENERATE-VERSION
new file mode 100755
index 0000000..6872a76
--- /dev/null
+++ b/GIT-GENERATE-VERSION
@@ -0,0 +1,24 @@
+#!/bin/sh
+# Get the git version if possible and store it in $GITFILE if it differs to
+# the one contained already.
+
+GITFILE=&quot;xorg-git-version.h&quot;
+
+if ! which git &gt; /dev/null; then
+    VER=&quot;Git not available.&quot;
+else
+    VER=`git describe HEAD 2&gt;/dev/null`
+
+    if test $? -ne 0; then
+        VER=&quot;Unknown version or not build from git.&quot;
+    fi
+fi
+
+if test -e &quot;$GITFILE&quot;; then
+    FILE_VER=$(sed -e &quot;s/^#define XORG_GIT_VERSION //&quot; &lt; $GITFILE)
+    if test &quot;$FILE_VER&quot; == &quot;$VER&quot;; then
+        exit 0
+    fi
+fi
+
+echo &quot;#define XORG_GIT_VERSION \&quot;$VER\&quot;&quot; &gt; $GITFILE
diff --git a/Makefile.am b/Makefile.am
index 8b7a2c8..cce5f23 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -49,7 +49,7 @@ pkgconfigdir = $(libdir)/pkgconfig
 pkgconfig_DATA = xorg-server.pc
 endif
 
-EXTRA_DIST = xorg-server.pc.in xorg-server.m4 autogen.sh
+EXTRA_DIST = xorg-server.pc.in xorg-server.m4 autogen.sh GIT-GENERATE-VERSION
 
 DISTCHECK_CONFIGURE_FLAGS=\
         --with-xkb-path=$(XKB_BASE_DIRECTORY) \
diff --git a/hw/xfree86/common/xf86Init.c b/hw/xfree86/common/xf86Init.c
index 71ac9a9..d37a292 100644
--- a/hw/xfree86/common/xf86Init.c
+++ b/hw/xfree86/common/xf86Init.c
@@ -34,6 +34,8 @@
 #include &lt;xorg-config.h&gt;
 #endif
 
+#include &lt;xorg-git-version.h&gt;
+
 #include &lt;stdlib.h&gt;
 #include &lt;errno.h&gt;
 
@@ -242,6 +244,9 @@ xf86PrintBanner(void)
   xf86ErrorFVerb(0, &quot;\tBefore reporting problems, check &quot;
                  &quot;&quot;__VENDORDWEBSUPPORT__&quot;\n&quot;
                  &quot;\tto make sure that you have the latest version.\n&quot;);
+#ifdef XORG_GIT_VERSION
+  xf86ErrorFVerb(0, &quot;git version: &quot; XORG_GIT_VERSION &quot;\n&quot;);
+#endif
 }
 
 static void
diff --git a/include/Makefile.am b/include/Makefile.am
index eddc86c..e052b8b 100644
--- a/include/Makefile.am
+++ b/include/Makefile.am
@@ -62,6 +62,11 @@ sdk_HEADERS =                \
 nodist_sdk_HEADERS = xorg-server.h
 endif
 
+BUILT_SOURCES = xorg-git-version.h
+
+xorg-git-version.h:
+        sh $(top_srcdir)/GIT-GENERATE-VERSION
+
 AM_CFLAGS = $(DIX_CFLAGS)
 
 EXTRA_DIST =         \
@@ -69,3 +74,5 @@ EXTRA_DIST =         \
         eventconvert.h eventstr.h \
         protocol-versions.h \
         xsha1.h
+
+DISTCLEANFILES = xorg-git-version.h
</PRE>
</BLOCKQUOTE>
<BR>
When I just run the script from the root dir, I get this:
<BLOCKQUOTE>
<PRE>
&gt;~/xorg/src/xserver$ ./GIT-GENERATE-VERSION
test: 22: &quot;xorg-server-1.8.0-40-ge35abc1&quot;: unexpected operator
</PRE>
</BLOCKQUOTE>
The xorg-git-version.h gets created correctly. The script just need to be a bit more robust, I guess.<BR>
<BR>
The file xorg-git-version.h should be added to include/.gitignore.<BR>
<BR>
Given that the purpose of this scheme is to &quot;log&quot; the most recent commit, the xorg-git-version.h should be<BR>
updated after the repo has been updated. This isn't the case now. I can do a git pull with new commits,<BR>
rebuild, and still get the same -ge35abc1. Perhaps it should be a PHONY target like ChangeLog. This would make<BR>
the information in log unreliable.<BR>
<BR>
A further improvement would be to run git show on the commit id (e.g. e35abc1) and write it to the log.<BR>
<BR>
<BR>
<BR>
<BR>
<BR>
</BODY>
</HTML>